/*
  mmlibtypes.h
  
  This file is part of mergemem by Philipp Richter & Philipp Reisner

  mergemem is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version.
  
  mergemem is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with mergemem; see the file COPYING.  If not, write to
  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef _MMLIBTYPES_H
#define _MMLIBTYPES_H

#ifdef __KERNEL__
#include <linux/types.h>
#include <linux/ioctl.h>
#else
#include <sys/types.h>
#include <sys/wait.h>
#endif

typedef struct
{
  const void * v_addr;   /* virtual address  */
  const void * p_addr;   /* physical address */
  size_t count;          /* reference count  */
  unsigned long hash;    /* hash             */
} MPAGEINFO;                 

typedef struct
{
  pid_t spid;      /* source pid */
  void * sv_addr;  /* source virtual address */
  pid_t dpid;      /* destination pid */
  void * dv_addr;  /* destination virtual address */
  int status;      /* return code */
} MEQUALPAIR;

#endif /* _MMLIBTYPES_H */
