#include <stdio.h>
#include <stdlib.h>
#include "../mmlib/mmlib.h"

#define MAX_NEL 1000

int main( int argc, char **argv )
{
  MPAGEINFO pi[MAX_NEL];
  int rr,i;
  pid_t pid;

  if(argc != 2) 
    {
      printf("USAGE: %s pid\n",argv[0]);
      exit(10);
    }

  pid = atoi(argv[1]);

  rr = m_getpageinfos( pid, (void *)0,  (void *)-1,pi,MAX_NEL,NULL);
  if(rr < 0) 
    {
      perror("ERROR ");
      exit(10);
    }

  printf("Anonymous pages of %d\n",pid);
  for(i=0;i<rr;i++)
    {
      printf("%3i: v%p p%p c%2ld\n",i,pi[i].v_addr,pi[i].p_addr,pi[i].count);
    }

  return 0;
}
